const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const databases = sequelize.define(
    'databases',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

database_kind: {
        type: DataTypes.ENUM,
      
      

        values: [

"notes",


"resources",


"study_materials",


"custom"

        ],

      },

default_view: {
        type: DataTypes.ENUM,
      
      

        values: [

"table",


"list",


"card",


"kanban",


"calendar"

        ],

      },

is_archived: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  databases.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













    db.databases.hasMany(db.database_entries, {
      as: 'database_entries_database',
      foreignKey: {
          name: 'databaseId',
      },
      constraints: false,
    });





















//end loop



    db.databases.belongsTo(db.workspaces, {
      as: 'workspace',
      foreignKey: {
        name: 'workspaceId',
      },
      constraints: false,
    });

    db.databases.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.databases.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.databases.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return databases;
};


